import listMissingPropertiesFrom from '../helper/listMissingProperties.js';
function everyItemOfArrayShouldHave(requiredProperties) {
    // return the vue validator function
    return function (array) { return scanArray(array, requiredProperties); };
}
function scanArray(array, requiredProperties) {
    var missingPropertiesInEachItem = array.map(function (item) {
        return listMissingPropertiesFrom(item, { requiredProperties: requiredProperties });
    });
    var hasAnyInvalidItemInArray = missingPropertiesInEachItem.some(function (item) {
        // if any item of this array has a length greater than zero it means
        // this property has an item with at least one property missing
        return item.length;
    });
    if (!hasAnyInvalidItemInArray) {
        return true;
    }
    else {
        console.error('Array (', array, ') has invalid items, see table below for missing itens:');
        console.table(missingPropertiesInEachItem);
        return false;
    }
}
export default everyItemOfArrayShouldHave;
//# sourceMappingURL=everyItemOfArrayShouldHave.js.map